#!/usr/bin/perl

#use strict;
#use warnings;
use File::Copy;
use CGI;
require 'account-admin-lib.pl';

#	Simple Email Function
#	($to, $from, $subject, $message)
sub sendEmail
{
	my ($to, $from, $subject, $message) = @_;
	my $sendmail = '/usr/lib/sendmail';
 	open(MAIL, "|$sendmail -oi -t");
 	print MAIL "From: $from\n";
 	print MAIL "To: $to\n";
 	print MAIL "Subject: $subject\n\n";
 	print MAIL "$message\n";
 	close(MAIL);
} 

ui_print_header(undef, $module_info{'desc'}, "");

#START  ------------------------------------------------------------------------

$debug = 0;
$toMail = "support\@nettools.se";
$fromMail = "root\@nettools.se";

$mailArchivePath = "/var/mail/";
$backupPath = "/var/mail/archive/";

$action = CGI::param('action');
$user = CGI::param('user');
$delete = CGI::param('delete');
$domain = $remote_user;

$atIndex = index($user, '@');
if($atIndex >= 0) {
	$username = substr($user, 0, $atIndex);
	$userMailFolder = "/home/" . $domain . "/homes/" . $username . "/mail/";
} else {
	$username = "";
	$userMailFolder = "/home/" . $domain . "/mail/";
}
$fileName = $user;
$fileName =~ s/\@/-/;

$dateTimeStr = strftime("%Y-%m-%d-%H:%M:%S", localtime);

$mailArchive = $mailArchivePath . $user;
$mailArchive =~ s/\@/-/;
$backupMailArchive = $backupPath . $user . "_" . $dateTimeStr;
$backupMailArchive =~ s/\@/-/;

if($debug == 1) {
	print "action: " . $action . "<br>";
	print "full user name: " . $user . "<br>";
	print "delete: " . $delete . "<br>";
	print "domain: " . $domain . "<br>";
	print "username: " . $username . "<br>";
	print "userMailFolder: " . $userMailFolder . "<br>";
	print "DateTime str: " . $dateTimeStr . "<br>";
}

if($action eq "delete" && $delete eq "true") {
	#print 'Unlink file: ' . $mailArchive . '<br>';
	if(-e $mailArchive) {
		#Make a backup
		copy($mailArchive, $backupMailArchive);

		unlink($mailArchive);
		$mailMsg = "Success: Mail archive was deleted: " . $mailArchive;
	} else {
		$stderr = "Error: Mail archive does not exist: " . $mailArchive;
	}
} elsif($action eq "move") {
	($login,$pass,$uid,$gid) = getpwnam($user);

	#Make a backup
	copy($mailArchive, $backupMailArchive);

	#Move file to users home mail folder
	#Create folder if not exists
	mkdir($userMailFolder);
	chown($uid, $gid, $userMailFolder);
	move($mailArchive, $userMailFolder);
	chown($uid, $gid, $userMailFolder . $fileName);

	#Convert mbox to Maildir
	$result = `/root/script/convert_mbox_to_maildir.sh $user`;
	#print $result;

	#Delete file from users home mail folder
	unlink($userMailFolder . $fileName);

	$mailMsg = "Success: Mail archive (" . $mailArchive . ") was moved to the users mail account: " . $userMailFolder . $fileName;
}



#END  ------------------------------------------------------------------------

if($debug == 1) {
	print '<br>Stdout: ' . $stdout . '<br>';
	print '<br>Stderr: ' . $stderr . '<p>';
}

if($stderr ne "") {
	print '<p><b>An error occured:</b><br>';
	print $stderr . '<br>';
	print 'Contact <a href="mailto:support@nettools.se">support@nettools.se</a> if this is incorrect.<br>';
	sendEmail($toMail, $fromMail, 'Account Admin Module - MailArchive - Error occured', $stderr);
} else {
	if($action eq "delete" && $delete ne "true") {
		print 'Do you really want to delete the mail archive for user ' . $user . '?<br>';
		print 'This action can not be undone.<p>';
		print '<a href="handle_mail_archive.cgi?delete=true&action=delete&user='.$user.'">Yes, delete mail archive!</a><p><a href="index.cgi">No, do not delete the archive</a>';
	} elsif($action eq "delete" && $delete eq "true") {
		print '<p><b>Success:</b><br>';
		print 'The mail archive is deleted.<br>';
		sendEmail($toMail, $fromMail, 'Account Admin Module - MailArchive - Delete successful', $mailMsg);
	} elsif($action eq "move") {
		print '<p><b>Success:</b><br>';
		print 'The mail archive is moved to the users mail account. It is added as a new folder.<br>';
		sendEmail($toMail, $fromMail, 'Account Admin Module - MailArchive - Move successful', $mailMsg);
	}
}

ui_print_footer('', $text{'first_page'});
