#!/usr/bin/perl

require './account-admin-lib.pl';

ui_print_header(undef, $module_info{'desc'}, "", undef);

$domainName = foreign_call('virtual-server', 'show_domain_name', $remote_user);
local @doms = foreign_call('virtual-server', 'list_domains');
foreach my $domain (@doms) {
	$dname = foreign_call('virtual-server', 'show_domain_name', $domain);
	#print $dname . ' ' . $domain . '<br>';
	if($dname eq $domainName) {
		$domainHash = $domain;
	}
}

#print 'Domain used in calls: ' . $domainName. ' ' . $domainHash . '<p>';
#print 'DEBUG: Logged in user: ' . $remote_user;

# Check that a domain really has been found
if($domainHash ne '') {

$domainId = $domainHash->{'id'};


@tds = ( "width=30%" );

print '<b>Quick links:</b>';
print ' ';
print '<a href="/virtual-server/list_users.cgi?dom=' . $domainId . '">Mail Users</a>';
print ' | ';
print '<a href="/virtual-server/list_aliases.cgi?dom=' . $domainId . '">Mail Aliases</a>';
print ' | ';
print '<a href="/virtual-server/view_domain.cgi?dom=' . $domainId . '">Virtual Server Details</a>';


# Show account info
print &ui_hidden_table_start('Account info', "width=100%", 2, "Account info", 1, \@tds);
print &ui_table_row('Domain name', "<tt>$domainName</tt>");
print &ui_table_row('Home directory', "<tt>$domainHash->{'home'}</tt>");
print &ui_hidden_table_end('Account info');


# Show total disk usage, broken down into unix user and mail users
print &ui_hidden_table_start('Quota', "width=100%", 2, "Quota", 1, \@tds);
print ui_table_row('Account quota', foreign_call('virtual-server', 'quota_show', $domainHash->{'quota'}, 'home'));
foreign_call('virtual-server', 'show_domain_quota_usage', $domainHash);

#foreign_call('virtual-server', 'show_domain_bw_usage', $domainHash);

print &ui_hidden_table_end('Quota');

# Mails saved when account over quota
print ui_subheading("Mail");

$mailAccountRegEx = $domainName . '$';

print 'When an account is over quota no mails will be delivered to the account. Instead they are saved in an archive on the server.<br>';
print '<b>Accounts with mail archives:</b>';
print '<table style="padding:5px;">';

$mailArchivesHtml = `find /var/mail -maxdepth 1 -size +0k -printf '%k %u\n' | grep $mailAccountRegEx  | awk '{print "<tr><td style=\\"padding:5px\\">"\$2"</td><td style=\\"padding:5px\\">"\$1 "KB</td><td><a href=\\"handle_mail_archive.cgi?action=move\&user="\$2"\\">Move</a></td><td><a href=\\"handle_mail_archive.cgi?action=delete\&user="\$2"\\">Delete...</a></td></tr>"}'`;

if(length($mailArchivesHtml) > 0) {
	print '<tr><td style="padding:5px"><b>Account</b></td><td style="padding:5px"><b>Size</b></td><td style="padding:5px"><b>Move archive to users mailbox</b></td><td style="padding:5px"><b>Delete archive</b></td></tr>';
	print $mailArchivesHtml;
} else {
	print '<tr><td style="padding:5px">No accounts with mail archives found</td></tr>';
}
print '</table>';
print '<p>';

#print &ui_hidden_table_end('Mail');

# Buttons to run commands
print ui_subheading("Commands");
print ui_buttons_start();
print ui_buttons_row('quota_borrow_quota.cgi', 'Double quota',
                       'Click this button to double the account quota for one hour.');
print ui_buttons_row('websvn_fix_permissions.cgi', 'Fix WebSVN permissions',
                       'Click this button to fix permission problems for <a href="http://websvn.tigris.org/" target="_blank">WebSVN</a>');
print ui_buttons_end();

} else {
	print '<b>Error occured:</b><br>';
	print 'The module is currently not working with your account.<br>';
	print 'This will only effect this module.<p>';
	print 'Please inform the support about this problem: <a href="mailto:support@nettools.se?subject=Problem with module Account Admin">Mail to support</a><br>';
}

ui_print_footer('/', $text{'index'});
